 # -*- coding: utf-8 -*-
#Boa:Frame:Frame1
"""
Joe Lanzone
Yale iGem 2015
11Sep15
"""
import wx
import math
import matplotlib.pyplot as plt
import processing_code.pcr_data_holder as data_holder
#import processing_code.processing_code as processor 


def create(parent):
    return Frame1(parent)

[wxID_FRAME1, wxID_FRAME1SIMULATE, wxID_FRAME1SPINCTRL1,
 wxID_FRAME1STATICTEXT1, wxID_FRAME1STATICTEXT2, wxID_FRAME1STATICTEXT3,
 wxID_FRAME1STATICTEXT4, wxID_FRAME1TEXTCTRL1, wxID_FRAME1TEXTCTRL2,
 wxID_FRAME1TEXTCTRL3, wxID_FRAME1TEXTCTRL4, wxID_FRAME1STATICTEXT5,
 wxID_FRAME1STATICTEXT6, wxID_FRAME1TEXTCTRL5,
 wxID_FRAME1STATICTEXT7,
] = [wx.NewId() for _init_ctrls in range(15)]

class Frame1(wx.Frame):
    data = data_holder.data_holder()
    m = 0
    Answer = []

    def _init_ctrls(self, prnt):
        # generated method, don't edit
        wx.Frame.__init__(self, id=wxID_FRAME1, name='', parent=prnt,
              pos=wx.Point(208, 102), size=wx.Size(1051, 625),
              style=wx.DEFAULT_FRAME_STYLE, title='Frame1')
        self.SetClientSize(wx.Size(1051, 603))
        #set up a menu
        filemenu= wx.Menu()

        # wx.ID_ABOUT and wx.ID_EXIT are standard ids provided by wxWidgets.
        menuAbout = filemenu.Append(wx.ID_ABOUT, "&About"," Information about this program")
        menuExit = filemenu.Append(wx.ID_EXIT,"E&xit"," Terminate the program")

       # wx.ID_ABOUT and wx.ID_EXIT are standard IDs provided by wxWidgets.
        filemenu.Append(wx.ID_ABOUT, "&About"," Information about this program")
        filemenu.AppendSeparator()
        filemenu.Append(wx.ID_EXIT,"E&xit"," Terminate the program")

         # Creating the menubar.
        menuBar = wx.MenuBar()
        menuBar.Append(filemenu,"&File") # Adding the "filemenu" to the MenuBar
        self.SetMenuBar(menuBar)  # Adding the MenuBar to the Frame content.

        self.Bind(wx.EVT_MENU, self.OnAbout, menuAbout)
        self.Bind(wx.EVT_MENU, self.OnExit, menuExit)

        self.staticText1 = wx.StaticText(id=wxID_FRAME1STATICTEXT1,
              label=u"\n\tWelcome to the Yale iGem 2015 PCR error propagation simulation program \n\n\tTo get started, please follow these simple steps: \n\t 1) Enter the sequence of the DNA strand that you will be replicating\n\t(Also fill the box above it with the name of your DNA sample)\n\t 2) Do the same for polymerase selection (to the right of that stuff enter the literature-derived error rate for your given polymerase.  Additional functionality NYI) \n\t 3) In the text field on the bottom right, enter the number of replications that you\'d like to run \n\t 4) Press the SIMULATE button and graphs should pop up showing the number of mutations that have appeared in your DNA per replication \n\tAfter generating the first graph, you can change the number of cycles visualized by using the up and down cilckers next to the \"cycles?\" field  \n\n\tEnjoy \n\tYale iGem 2015",
              name='staticText1', parent=self, pos=wx.Point(16, 24),
              size=wx.Size(4190, 304), style=0)

        self.textCtrl1 = wx.TextCtrl(id=wxID_FRAME1TEXTCTRL1, name='textCtrl1',
              parent=self, pos=wx.Point(40, 460), size=wx.Size(282, 82),
              style=0, value='')
        self.textCtrl1.Bind(wx.EVT_TEXT_ENTER, self.OnTextCtrl1TextEnter,
              id=wxID_FRAME1TEXTCTRL1)

        self.textCtrl2 = wx.TextCtrl(id=wxID_FRAME1TEXTCTRL2, name='textCtrl2',
              parent=self, pos=wx.Point(360, 460), size=wx.Size(338, 82),
              style=0, value='')
        self.textCtrl2.Bind(wx.EVT_TEXT_ENTER, self.OnTextCtrl2TextEnter,
              id=wxID_FRAME1TEXTCTRL2)

        ##establish textcontrols 3, 4 and 5
          #text boxes near their related boxes.
        self.textCtrl3 = wx.TextCtrl(id=wxID_FRAME1TEXTCTRL3, name='textCtrl3', 
          parent = self, pos = wx.Point(40, 400), size=wx.Size(282, 40),
          style = 0, value = '')

        self.staticText5 = wx.StaticText(id=wxID_FRAME1STATICTEXT5,
          label='DNA strand name', name='staticText5', parent=self,
          pos=wx.Point(40, 380), size=wx.Size(67, 24), style=0)

        self.textCtrl4 = wx.TextCtrl(id=wxID_FRAME1TEXTCTRL4, name='textCtrl4', 
          parent = self, pos = wx.Point(360, 400), size=wx.Size(282, 40),
          style = 0, value = '')

        self.staticText6 = wx.StaticText(id=wxID_FRAME1STATICTEXT6,
          label='Polymerase name?', name='staticText6', parent=self,
          pos=wx.Point(360, 380), size=wx.Size(67, 24), style=0)

        self.spinCtrl1 = wx.SpinCtrl(id=wxID_FRAME1SPINCTRL1, initial=0,
              max=100, min=0, name='spinCtrl1', parent=self, pos=wx.Point(736,
              460), size=wx.Size(120, 56), style=wx.SP_ARROW_KEYS)

        self.textCtrl5 = wx.TextCtrl(id=wxID_FRAME1TEXTCTRL5, name='textCtrl5', 
          parent = self, pos = wx.Point(736, 400), size=wx.Size(120, 40),
          style = 0, value = '')

        self.staticText7 = wx.StaticText(id=wxID_FRAME1STATICTEXT7,
          label='Polymerase error rate (literature-derived)', name='staticText7', parent=self,
          pos=wx.Point(736, 380), size=wx.Size(67, 24), style=0)

        self.spinCtrl1.Bind(wx.EVT_TEXT_ENTER, self.OnSpinCtrl1TextEnter,
              id=wxID_FRAME1SPINCTRL1)
        self.spinCtrl1.Bind(wx.EVT_SPIN_UP, self.OnSpinCtrl1SpinUp,
              id=wxID_FRAME1SPINCTRL1)
        self.spinCtrl1.Bind(wx.EVT_SPIN_DOWN, self.OnSpinCtrl1SpinDown,
              id=wxID_FRAME1SPINCTRL1)
        self.spinCtrl1.Bind(wx.EVT_SPIN, self.OnSpinCtrl1Spin,
              id=wxID_FRAME1SPINCTRL1)

        self.SIMULATE = wx.Button(id=wxID_FRAME1SIMULATE, label=u'SIMULATE',
              name=u'SIMULATE', parent=self, pos=wx.Point(904, 496),
              size=wx.Size(120, 120), style=0)
        
        self.SIMULATE.Bind(wx.EVT_BUTTON, self.OnSIMULATEButton,
              id=wxID_FRAME1SIMULATE)

        self.staticText2 = wx.StaticText(id=wxID_FRAME1STATICTEXT2,
              label='Enter DNA sequence below', name='staticText2', parent=self,
              pos=wx.Point(40, 440), size=wx.Size(272, 24), style=0)

        self.staticText3 = wx.StaticText(id=wxID_FRAME1STATICTEXT3,
              label='Enter polymerase sequence below (NYI)', name='staticText3', parent=self,
              pos=wx.Point(360, 440), size=wx.Size(320, 16), style=0)

        self.staticText4 = wx.StaticText(id=wxID_FRAME1STATICTEXT4,
              label='No of Cycles?', name='staticText4', parent=self,
              pos=wx.Point(736, 440), size=wx.Size(67, 24), style=0)

    def __init__(self, parent):
        self._init_ctrls(parent)

    def OnAbout(self, event):
        dlg = wx.MessageDialog( self, "A basic PCR simulation program", "About Sample Editor", wx.OK)
        dlg.ShowModal() # Show it
        dlg.Destroy() # finally destroy it when finished.

    def OnExit(self,e):
        self.Close(True)  # Close the frame.

    def OnTextCtrl1TextEnter(self, event):
      #a = data.set_dna_info(self.textCtrl1.GetValue(), "Test_DNA_NAME")
      #print "1"
      event.Skip()

    def OnTextCtrl2TextEnter(self, event):
        #data.set_poly_info(self.textCtrl2.GetValue(), "Test_polymerase_name")
        event.Skip()

    def OnSpinCtrl1TextEnter(self, event):
        #data.set_iteration_number(self.spinCtrl1.GetValue() 
        event.Skip()

    def OnSpinCtrl1SpinUp(self, event):
        #self.spinCtrl1.GetValue()
        event.Skip()

    def OnSpinCtrl1SpinDown(self, event):
        #self.spinCtrl1.GetValue()
        event.Skip()

    def OnSpinCtrl1Spin(self, event):
        #self.spinCtrl1.GetValue()
        event.Skip()
    
    def OnSIMULATEButton(self, event):
        """
        At the moment, the polymerase data is going to be largely ignored, b/c we're using specific literature
        values.
        The extra text box for polymerase error rate covers that

        """
        Dna_info = self.data.set_dna_info(self.textCtrl1.GetValue(), self.textCtrl3.GetValue())
        polymerase_info = self.data.set_poly_info(self.textCtrl2.GetValue(), self.textCtrl4.GetValue(), self.textCtrl5.GetValue())
        iteration_number = self.data.set_iteration_number(self.spinCtrl1.GetValue())
        user_input_data = self.data.get_dict()

        G = user_input_data["dna_info"]["sequence_length"]
        u = user_input_data["poly_info"]["err_rate"]
        m = 0
        equation_lambda = 1
        rounds = user_input_data["iter_count"]
        
        self.simulatee(G, u, m, equation_lambda, rounds, user_input_data)
    
    def simulatee(self, G, u, m, equation_lambda, rounds, user_input_data):
        for n in range(1, rounds + 1):
            front = ((u*G)**m)*(1+equation_lambda*math.exp(-u*G))**n/((math.factorial(m))*(1+equation_lambda)**n)
            bino = ((n*equation_lambda*math.exp(-u*G))/(equation_lambda*math.exp(-u*G)+1))**m
            user_input_data["graph_data"]["iteration"].append(n)
            """
            (front*bino) is the probability of an error popping up @ a given position G is sequence length, so, that, times probability of errors will give total errors a strand @ a given length
            """
            user_input_data["graph_data"]["total_errors"].append(math.log((front*bino)*G**n))
            
            if len(self.Answer) == 0:
                user_input_data["graph_data"]["percent_error"].append(front*bino)
            else:
                user_input_data["graph_data"]["percent_error"].append(user_input_data["percent_error"][-1]+ (front*bino))

        fig = plt.figure(1)
        ax1 = fig.add_subplot(211, title = 'Proportion of Fragment Free' + user_input_data["dna_info"]["dna_name"] + " per cycle:",
                                                 ylabel = "Error Free Fragment Proportion")
        ax1.plot(user_input_data["graph_data"]["iteration"],user_input_data["graph_data"]["percent_error"])

        ax2 = fig.add_subplot(212, title = 'Actual Number of Fragments With Errors (log):',
                                                xlabel = 'Number of PCR Cycles', ylabel = "log(Number of Fragents With Errors)")
        ax2.plot(user_input_data["graph_data"]["iteration"], user_input_data["graph_data"]["total_errors"])

        plt.show()




        #error_finder = processor.error_finder()
        #error_finder.get_number_of_errors(user_input_data)
