# -*- coding: utf-8 -*-
"""
Joe Lanzone
12Sep15
10:15 AM
"""
from __future__ import division
import re


class data_holder:
	"""
	initializes the dictionary that will hold all of the data used by the 
	processing function
	"""
	def __init__(self):
		self.complete_data_container = {
					"dna_info":
						{
						"dna_name": "",
						"literal_sequence": "",
						"sequence_length": 0,
						"GC": 0,
						"melt_temp": 0
						},
					"poly_info":
						{
						"polymerase_name": "",
						"literal_sequence": "",
						"err_rate": 0
						},
					"iter_count": 0,
					"graph_data":
						{
						"total_errors": [],
						"percent_error": [],
						"iteration": []
						}
					}

	def set_dna_info(self, dna_string, dna_name):
		#self.complete_data_container["dna_info"]["dna_name"] = dna_name
		self.complete_data_container["dna_info"]["literal_sequence"] = str(dna_string)
		self.complete_data_container["dna_info"]["sequence_length"] = len(dna_string)
		self.complete_data_container["dna_info"]["GC"] = self.find_gc_content(dna_string)
		self.complete_data_container["dna_info"]["dna_name"] = str(dna_name)
		###Melting temperature calculations not yet implemented
		self.complete_data_container["dna_info"]["melt_temp"] = 0

	def set_poly_info(self, polymerase_string, polymerase_name, error_rate):
		self.complete_data_container["poly_info"]["polymerase_name"] = str(polymerase_name)
		self.complete_data_container["poly_info"]["literal_sequence"] = str(polymerase_string)
		self.complete_data_container["poly_info"]["err_rate"] = float(error_rate)

	def find_gc_count(self, dna_string):
		#uses python regular expressions to count all instances of G or C in the DNA strand
		g_c = len(re.findall("G|g|C|c", dna_string))
		return g_c

	def find_gc_content(self, dna_string):
		#returns gc/strand length

		gc_count = float(self.find_gc_count(dna_string))
		gc_content = gc_count/len(dna_string)

		return gc_content

	def set_iteration_number(self, iternumber):
		self.complete_data_container["iter_count"] = int(iternumber)

	def get_dict(self):
		return self.complete_data_container